<template>
	<Page class="page">
		<ActionBar class="action" title="Octanium | Mantenimiento">
			<NavigationButton
			:icon="classMenu"
			@tap="openCloseDrawer()"/>

			<ActionItem @tap="logOut"
      		android.systemIcon="ic_menu_more"
			text="logOut"
			android.position="popup">
			</ActionItem>
		</ActionBar>
	    <RadSideDrawer ref="drawer" @drawerOpened="sideActive=true" @drawerClosed="sideActive=false">
        	<StackLayout ~drawerContent>
				<ListSideDrawer height="100%" @closeDrawerTap="openCloseDrawer()"></ListSideDrawer>
			</StackLayout>
			<StackLayout ~mainContent>
				<GridLayout rows="auto">					
					<RadListView ref="listView"
					pullToRefresh="true"
					for="item in items"
					@pullToRefreshInitiated="onPullToRefreshInitiated">
						<v-template name="header">
							<StackLayout class="header boring" ref="pullBar">
								<DockLayout stretchLastChild="true" stretch="fill">
									<Label class="fa" dock="left" :style="{'text-align': 'right'}" width="20%" :text="'\uf103'"/>
									<Label text=" deslizar hacia abajo para actualizar"></Label>
								</DockLayout>
							</StackLayout>	
						</v-template>
						<v-template>
							<StackLayout orientation="vertical">
								<GridLayout rows="auto" columns="*,*,*,*,*,*,*">
									<ListLabel @onListItemTaped="onItemTaped(item.id)" :item="item" :colSpan="7"></ListLabel>
									<MenuButton @listado="obtenerActividades()" top="4" :item="item" colSpan="7"/>
								</GridLayout>
							</StackLayout>
						</v-template>
					</RadListView>
					<ActivityIndicator :busy="processing" color="#7d00cc"></ActivityIndicator>
				</GridLayout>
			</StackLayout>
    	</RadSideDrawer>
	</Page>
</template>

<script>
// components
import Login from './Login';
import ListLabel from '../components/item-list/ListLabel';
import MenuButton from '../components/item-list/MenuButton';
import ListSideDrawer from '../components/ListSideDrawer'; 
// libraries
import axios from 'axios';
import { urlApi } from '../main.js';
import { requestPermissions } from "nativescript-camera";
import { AnimationCurve } from "tns-core-modules/ui/enums";
import { Color } from "tns-core-modules/color";
import { mapGetters } from 'vuex';
import * as Toast from 'nativescript-toast';

export default {
	
	data() {
		return {
			processing: false,
			sideActive:false,
			isActive: false
		}
	},
	computed:{
		classMenu(){
			return this.sideActive ? 'res://ic_menu_close':'res://ic_menu_w';
		},
		// user(){
		// 	return this.$store.getters.getUser;
		// },
		...mapGetters({
			items: 'getItems',
			user: 'getUser'
		})
	},
	beforeMount() {
		this.obtenerActividades();
		this.onRequestPermissions();
	},
	methods: {
		obtenerActividades(listaPulled){
			if(!listaPulled)
				this.processing = true;

			let Api;
			if(this.user.role == 4){
				Api = urlApi+`/api/v1/mtto/user/supervisor/actividad-supervisar`;
			}else{
				Api = urlApi+`/api/v1/mtto/user/${this.user.id}/actividad-trabajar`;
			}
			
			axios.get(Api)
			.then(respuesta => {
				this.processing = false;
				if(listaPulled){
					listaPulled.notifyPullToRefreshFinished();
				}
				if(respuesta.data.length == 0)
					Toast.makeText("Sin actividades aun!!!","long").show();
				
				var items = respuesta.data;
				this.$store.dispatch('setItems', items);				
			})
			.catch(error =>{
				this.processing = false;
				Toast.makeText(`${error}`,"long").show();
				if(this.items.length == 0){
					this.$store.dispatch('setItems', []);
				}
			});
		},
		onItemTaped(itemList){
			console.log('item pressed:', itemList);
		},
		onRequestPermissions() {
			// >> camera-module-perm-code
			requestPermissions();
			// << camera-module-perm-code
		},
		logOut(){
			this.$store.dispatch('logOut')
			.then(resp=>{
				this.$navigateTo(Login);
			});
		},
		openCloseDrawer() {
			if(this.sideActive == false){
				this.$refs.drawer.nativeView.showDrawer();
				this.sideActive = true; 
			}else{
				this.$refs.drawer.nativeView.closeDrawer();
				this.sideActive = false; 
			}
		},
		onPullToRefreshInitiated ({ object }) {
			console.log('Pulling...');
			let pullBar = this.$refs.pullBar.nativeView;
			pullBar.animate({
				backgroundColor: new Color("#00636e"),
				duration: 1000,
				opacity: 0.9,
				scale: {
					x: 2,
					y: 2
				},
				translate: {
					x: 50,
					y: 0
				}
			});
			this.obtenerActividades(object);
		}
	},
	components: { MenuButton, ListLabel, ListSideDrawer }
}
</script>

<style scoped>
	.header{
		color: white;
		background-color: #490d66;
		margin-bottom: 10;
		padding: 15 0;
	}

	.boring{
        border-width: 0 0 2 0;
        border-color: white;
    }
</style>
